<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">
<html>
<head>
  <title>פגישה 7 - תנאים (אם....אז....אחרת!)</title>
 
  <meta http-equiv="content-type"
 content="text/html; charset=UTF-8">
 
  <link href="lec.css" rel="stylesheet" type="text/css">
<!-- LINKS --><!-- TOC<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">
<html>
<head>
  <title>פגישה 5 - תנאים (אם....אז....אחרת!)</title>
  <LINK href="toc.css" rel="stylesheet" type="text/css">           
  <link rel="next" href="node1.html#h">
  <link rel="first" href="node1.html#h">
  <link rel="start" href="node1.html#h">

  <meta http-equiv="content-type"  content="text/html; charset=UTF-8">
</head>
<body>
גרסה 1.1
<h1>פגישה 7 - תנאים )אם....אז....אחרת!)</h1>
<div class="start"><a href="node1.html#h">[לחצו כאן כדי להתחיל]</a></div>
<div class="note">הרצאה זו קיימת גם כ-<a href="meeting7-ifs.html">קובץ HTML
אחד גדול</a>.</div>
<h2>תוכן העניינים</h2>
<toc/>
<address><a href="http://validator.w3.org/check/referer"><img src="http://www.w3.org/Icons/valid-html401" alt="Valid HTML 4.01!" height="31" width="88"></a>נכתב על ידי <a href="mailto:choo@actcom.co.il">גיא קרן</a><br>
</address>
</body>
</html>
TOC -->
</head>
<body>
  
גרסה 1.1
<h1>פגישה 7 - תנאים (אם....אז...אחרת!)</h1>
  <!-- BEGIN -->                  
<h2><a name="if_then"></a>שיעורון ד' - יש לי תנאי</h2>
                   
<ul>
  <li>תוכנית מחשב הופכת לתוכנית אמיתית כאשר יש בה התלבטויות</li>
  <li>התלבטות ניתנת להבעה באמצעות פקודת תנאי - אם .... אז ....</li>
  <li>ובשפת פייתון:
    <div dir=ltr><pre>
     if x &lt; 10:
         print "x is smaller than 10"
    </pre></div>
      (אם x קטן מעשר, אז הדפס עובדה זו).
      </li>
  <li>או למשל תנאי מורכב יותר:
    <div dir=ltr><pre>
     if x &gt; 10 and x &lt; 20:
         x = x * 2
         print "x was doubled, and it is now ", x
    </pre></div>
      (אם x גדול מעשר וקטן מעשרים, אז הכפל אותו פי שתיים, והדפס את ערכו החדש).
      </li>
  <li>ניתן להשתמש במילה or כדי לאמר "אם תנאי אחד או תנאי שני"</li>
           
</ul>
                  
<h3><a name="if_then_else"></a>אם... אז... אחרת...</h3>
     
<ul>
     <li>לפעמים רוצים לטפל גם במקרה שהתנאי אינו מתקיים - אם... אז... אחרת...</li>
     <li>ובפייתון:
    <div dir=ltr><pre>
     if x &lt; 10:
         print "x is smaller than 10"
     else:
         print "x is larger than 10 or equals 10"
    </pre></div>
      (אם x קטן מעשר, אז הדפס עובדה זו, אחרת הדפס ש-x גדול מעשר או שווה לעשר).
      </li>
     <li>או למשל:
    <div dir=ltr><pre>
     if a &gt;= b:
         max = a
     else:
         max = b
    </pre></div>
      (חישוב המספר הגדול משני מספרים: אם a גדול מ-b או שווה לו, אז הצב את a
       ב-max, אחרת הצב את b ב-max).
      </li>
</li>
     
</ul>
                    
<h3><a name="comments"></a>הערת ביניים - הערות בפייתון</h3>
     
<ul>
    <li>ככל שהתוכניות שלנו נעשות גדולות ומורכבות יותר, קשה לחזור לתוכנית אחרי
        שבוע ולהבין מה כתוב בה.</li>
    <li>לשם כך, היה נחמד אם היינו יכולים לשרבט ליד חלקים שונים של התוכנית, מה
        הם עושים.</li>
    <li>ובפייתון - רושמים שורות עם הערות. כל שורה המתחילה סימן # (סולמית) נחשבת
        לשורת הערה.</li>
    <li>פייתון מתעלמת משורות ההערה - כך שאפשר לכתוב בהן מה שאנחנו רוצים. למשל:
    <div dir=ltr><pre>
    # print the numbers from 1 to 10.
    i = 1
    while i <= 10:
        print i

    # now do the same, from 10 to 1
    i = 10
    while i > 0:
        print i
    </pre></div>
    </li>
</ul>

<h3><a name="while_as_if"></a>שימוש בלולאת "כל-עוד" כתנאי</h3>
     
<ul>
     <li>עד היום השתמשנו בלולאות "כל-עוד" בעיקר כדי לספור.</li>
     <li>אפשר להשתמש בהן גם כדי לכתוב משחק.</li>
     <li>למשל במשחק הזיכרון - אנחנו מעוניינים לתת למשתמש להפוך קלפים שוב ושוב,
         עד שהמשחק מסתיים.</li>
     <li>ובפייתון:
    <div dir=ltr><pre>
     # variable 'game_over' will be used to flag the end of the game.
     game_over = 0
     while not game_over:
         # handle one turn of the game here.
         .
	 .
	 # somewhere, we need to decide that the game is over.
	 if .....:
	     game_over = 1
    </pre></div>
      (תחילה סמן שהמשחק לא נגמר {<class dir=ltr>game_over = 0</class>}. לאחר
      מכן, כל עוד המשחק לא נגמר, בצע את התור הבא. אם במהלת התור מזהים שהמשחק
      נגמר, מסמנים זאת על-ידי שינוי game_over ל-1, ובפעם הבאה הלולאה תסתיים).
      </li>

</ul>

<h3><a name="while_as_if"></a>שימוש בלולאת "כל-עוד" אין-סופית</h3>
     
<ul>
     <li>ניתן לחליפין להשתמש בלולאת "כל-עוד" אין-סופית, ולסיימה באמצע על-ידי
        שימוש בפקודה break.</li>
     <li>פקודה זו גורמת ליציאה _מיידית_ מהלולאה שבתוכה היא
	רשומה, מבלי להשלים את שאר פקודות הלולאה:
    <div dir=ltr><pre>
     while true:
         # handle one turn of the game here.
	 .
	 .
	 # somewhere, we need to decide that the game is over.
	 if .....:
	     break
    </pre></div>
      (בצע את המשחק בתוך לולאה אין-סופית. בשלב כלשהו שבו נגלה שהמשחק נגמר,
       נצא מהלולאה האין-סופית על-ידי שימוש בפקודה break).
      </li>
</li>
     
</ul>
                    
<h3><a name="raw_input"></a>כלי קטן - קריאה מהמקלדת</h3>
     
<ul>
     <li>אחד הכלים הדרושים כדי לתקשר עם המשתמש, הוא היכולת לקבל ממנו נתונים.</li>
     <li>בפייתון, משתמשים בפונקציה raw_input כדי לקרוא קלט:
    <div dir=ltr><pre>
     num_string = raw_input("give me a number: ")
    </pre></div>
      (הצג למשתמש את ההודעה ":give me a number", וקלוט ממנו נתון. המשתמש
       יקליד מספר או מחרוזת, וילחץ על מקש ה-ENTER להמשך).
     </li>
     <li>פונקציית raw_input מחזירה מחרוזת. כדי שנוכל לבצע חישובים על המחרוזת,
         יש לתרגמה למספר על-ידי הפונקציה int:
    <div dir=ltr><pre>
     num_string = raw_input("give me a number: ")
     num = int(num_string)
    </pre></div>
      (כמו מקודם - אבל הפעם תרגם את הקלט למספר).
     </li>

</ul>

<h3><a name="raw_input"></a>כלי קטן - קריאה מהמקלדת (המשך)</h3>
     
<ul>
     <li>ובחיבור שתי הפונקציות ביחד:
    <div dir=ltr><pre>
     num_string = int(raw_input("give me a number: "))
    </pre></div>
     </li>
     <li>שימו לב: אם ניתן לפונקציה int מחרוזת שאינה נראית כמו מספר חוקי, נקבל
         שגיאה:
    <div dir=ltr><pre>
&gt;&gt;&gt; num = int("hello")
Traceback (most recent call last):
  File "&lt;stdin&gt;", line 1, in ?
ValueError: invalid literal for int(): hello
    </pre></div>
      </li>
     
</ul>
                    
<h3><a name="game_3"></a>משחק שלישי - נחש את המספר</h3>
     
<ul>
     <li>כיתבו תוכנית, שבה המחשב "בוחר" מספר באופן שרירותי (למשל, num = 50),
         ונותן למשתמש לנחש מה המספר.</li>
     <li>בכל שלב, המחשב מבקש מהמשתמש מספר, ומודיע לו אם המספר שניחש קטן
         מהמספר שבחר המחשב, גדול ממנו או זהה לו.</li>
     <li>אם המספר זהה, התוכנית מסתיימת.</li>
     <li>העזרו בכלים שהכרנו עד עתה - ...if, while, print, raw_input, int</li>
     <li>כיתבו את גוף המשחק תוך שימוש בלולאת "כל-עוד", כפי שראינו היום.</li>
     <li>כיתבו הערות בתוך התוכנית, כדי שאתם (ואנשים אחרים) תוכלו להבין אותה
         בקלות כשתקראו אותה שוב.</li>
     <li>הערה: מאחר והמספר ש"בחר" המחשב הוא למעשה מספר שרשמתם בתחילת התוכנית,
         תנו למישהו אחר לשחק במשחק, כדי שבאמת יהיה צורך לנחש :)</li>
     
</ul>

<!-- END -->                   
<address><a href="http://validator.w3.org/check/referer"><img
 src="http://www.w3.org/Icons/valid-html401" alt="Valid HTML 4.01!"
 height="31" width="88">
 </a>נכתב על ידי <a href="mailto:choo@actcom.co.il">גיא קרן</a><br>
          </address>
                   
</body>
</html>
